<?php
$TITLE = "";
$MODULES = array("config", "graph", "wiki");


$READER_DB_DVIN = array(
	"dvin_asec" => array (
	    "title" => _("DVIN"),
	    "reader" => "DVINReader",
	    "driver" => "mysql",
	    "host" => "localhost",
	    "port" => 0,
	    "user" => "asec",
	    "password" => 'asecpw',
	    "database" => array("asec"),
	    "persistent" => true
//	    "charset" => "ISO8859-1",
//	    "disconnected" => true
	),
	"dvin_nmdb" => array (
	    "title" => _("NMDB"),
	    "reader" => "DBReader",
	    "driver" => "mysql",
	    "host" => "134.245.71.224",
	    "port" => 0,
	    "user" => "nmdb",
	    "password" => '',
	    "database" => array("nmdb"),
	    "persistent" => true,
//	    "charset" => "ISO8859-1",
//	    "disconnected" => true
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_DVIN, $READER_DB);
else $READER_DB = $READER_DB_DVIN;

$OPTIONS["dvin_asec__asec"] = array(
	    "groups" => array(
		"/^all$/" => 'finalASEC',
	    ),
	    "tables" => array(
		"/^finalASEC$/" => array(
		    'gid' => 'all',
		    'title' => 'ASEC'
		)
	    ),
	    "columns" => array(
		"time" => "Time",
		"data" => "/^(C\d+)$/"
	    ),
//	    "timezone" => "Europe/Berlin",
//	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
//	    "date_limit" => "1970-01-01 00:00:00",		//GMT
	    "min_resolution" => 600,
	    "maximal_allowed_gap" => 120,
	    "ignore_subseconds" => true,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => false,
	    "trace_timings" => false,
	    "monitor_timings" => array(
		"query_limit" => 500000,		/* us */
		"raise_exception" => true
	    )
);

$OPTIONS["dvin_nmdb__nmdb"] = array(
	    "groups" => array(
		"/^(.*)$/" => '${1}',
	    ),
	    "tables" => array(
		"/^((\w+)_1h)$/" => array(
		    'gid' => '${1}',
		    'title' => '${2}: Hourly Data'
		),    
		"/^((\w+)_ori)$/" => array(
		    'gid' => '${1}',
		    'title' => '${2}: Original Data'
		),
	    ),
	    "columns" => array(
		"time" => "start_date_time",
		"data" => "/^(uncorrected|corr_.*|pressure_mbar|measured_.*)$/"
	    ),
//	    "timezone" => "Europe/Berlin",
//	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
//	    "date_limit" => "1970-01-01 00:00:00",		//GMT
	    "min_resolution" => 43200,
	    "ignore_subseconds" => true,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => false,
	    "trace_timings" => false,
	    "monitor_timings" => array(
		"query_limit" => 500000,		/* us */
		"raise_exception" => true
	    )
);

?>