<?php
$TITLE = "Weather Station";
$MODULES = array("config", "graph", "wiki");

$ADEI_TIMINGS = array (
	_("1 Year") => 31536000,
	_("1 Month") => 2592000,
	_("1 Week") => 604800,
	_("1 Day") => 86400,
	_("6 Hours") => 21600,
	_("1 Hour") => 3600,
	_("15 Min") => 900,
	_("10 Min") => 600,
	_("5 Min") => 300
);


$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	),
	"tdms" => array(
	    'title' => "TDMS",
	    'handler' => "LABVIEW",
	    'type' => "tdms"
	)
);


$READER_DB_WT = array(
/*	"imk" => array (
	    "title" => _("IMK"),
	    "reader" => "DBReader",
	    "driver" => "odbc",
	    "sqldrv" => "mssql",
	    "subdrv" => "FreeTDS",
	    "host" => "192.168.8.6",
	    "port" => 1433,
	    "user" => "souren",
	    "password" => '$souren$',
	    "database" => array("KFK_Mast"),
	    "charset" => "ISO8859-1",
	    "timeout" => 200000,	// us
	    "ping" => true,		// host and port should be specified
//	    "disconnected" => true
	),*/
	"mast" => array (
	    "title" => _("Weather Tower"),
	    "reader" => "IPEReader",
	    "driver" => "odbc",
	    "sqldrv" => "mssql",
	    "subdrv" => "FreeTDS",
	    "host" => "imkmastdb2.ka.fzk.de",
	    "port" => 1433,
	    "user" => 'souren',
	    "password" => '$souren$',
	    "database" => array("Mastdaten_rep", "MastdatenArchiv"),
	    "charset" => "ISO8859-1",
	    "timeout" => 200000,	// us
	    "ping" => true,		// host and port should be specified
	    "disconnected" => false
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_WT, $READER_DB);
else $READER_DB = $READER_DB_WT;



$OPTIONS["imk__KFK_Mast"] = array(
	    "groups" => array(
		"/^(.*)$/" => '${1}',
	    ),
	    "tables" => array(
		"/^(HV1|TW1|U1)$/" => array(
		    'gid' => '${1}',
		    'title' => '${1}'
		)
	    ),
	    "columns" => array(
		"time" => "DATUM",
		"data" => "/_/"
	    ),
	    "timezone" => "Europe/Berlin",
//	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
	    "date_limit" => "2000-01-01 00:00:00",		//GMT
//	    "date_limit" => array("2005-08-06 00:00:00","2005-08-08 00:00:00"),		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "min_resolution" => 600,
	    "ignore_subseconds" => false,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
//	    "use_md5_postfix" => true,
	    "trace_timings" => false,
	    "monitor_timings" => array(
		"query_limit" => 500000,		/* us */
		"raise_exception" => true
	    ),
	    "cache_config" => array(
		array("min" => 630720000, "res" => 604800),
		array("min" => 31536000, "res" => 43200)
	    ),
	    "data_filters" => array(
		"BADVALUEFilter" => array (
		    "badvalue" => 1999
		),
	    )
);


$OPTIONS["mast"] = array(
	    "groups" => array(
		"/^(.*)Archive$/" => 'Wv$ArchivData$${1}',
		"/^(.*)Calc$/" => 'Wv$CalcData$${1}',
		"/^(.*)$/" => 'Wv$LiveData$${1}',
	    ),
	    "tables" => array(
		"/^Wv\\\$LiveData\\\$([\w\d_]+)$/" => array(
//		"/^Wv\\\$LiveData\\\$(Analog|DewPoint|Precipitation|Temperature|WindSpeed)$/" => array(
		    'gid' => '${1}',
		    'title' => '${1} Live'
		),
		"/^Wv\\\$CalcData\\\$([\w\d_]+)$/" => array(
//		"/^Wv\\\$CalcData\\\$(Analog|DewPoint|Precipitation|Temperature|WindSpeed)$/" => array(
		    'gid' => '${1}Calc',
		    'title' => '${1} Calculated'
		),
		"/^Wv\\\$ArchivData\\\$([\w\d_]+)$/" => array(
//		"/^Wv\\\$CalcData\\\$(Analog|DewPoint|Precipitation|Temperature|WindSpeed)$/" => array(
		    'gid' => '${1}Archive',
		    'title' => '${1} Archive '
		)
	    ),
	    "columns" => array(
		"time" => "WsDateTimeTicks",
		"data" => "/^MT_/"
	    ),
	    "timezone" => "Europe/Berlin",
	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
//	    "date_limit" => "2000-01-01 00:00:00",		//GMT
//	    "date_limit" => array("2005-08-06 00:00:00","2005-08-08 00:00:00"),		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "min_resolution" => 60,
	    "ignore_subseconds" => true,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => false,
	    "trace_timings" => false,
	    "monitor_timings" => array(
		"query_limit" => 500000,		/* us */
		"raise_exception" => true
	    ),
/*	    "cache_config" => array(
		array("min" => 630720000, "res" => 604800),
		array("min" => 31536000, "res" => 43200)
	    ),
	    "data_filters" => array(
		"BADVALUEFilter" => array (
		    "badvalue" => 1999
		),
	    )*/
	    "channel_uids" => "/^MT_/",
	    "axis" => array(
		"/^MT_PT_T_AIR/i" => "temperature"
	    )
);

$OPTIONS["mast__Mastdaten_rep__Licor"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__LicorCalc"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic1"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic1Calc"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic2"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic2Calc"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic3"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic3Calc"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic4"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

$OPTIONS["mast__Mastdaten_rep__Sonic4Calc"] = array(
	    "min_resolution" => 10,
	    "ignore_subseconds" => false
);

?>
